package gmodel

import (
	"context"
	"gorm.io/gorm"
)

type FsStandardLogo struct {
	Id     int64   `gorm:"primary_key" json:"id"`   // ID
	Name   *string `gorm:"default:''" json:"name"`  // logo名称
	Image  *string `gorm:"default:''" json:"image"` // 图片地址
	Ctime  *int64  `gorm:"default:0" json:"ctime"`  // 添加时间
	Status *int64  `gorm:"default:1" json:"status"` // 状态 1正常 0删除
}
type FsStandardLogoModel struct {
	db *gorm.DB
}

func NewFsStandardLogoModel(db *gorm.DB) *FsStandardLogoModel {
	return &FsStandardLogoModel{db}
}
func (l *FsStandardLogoModel) GetAll(ctx context.Context) (resp []FsStandardLogo, err error) {
	err = l.db.WithContext(ctx).Model(&FsStandardLogoModel{}).Where("`status` = ? ", 1).Find(&resp).Error
	if err != nil {
		return nil, err
	}
	return
}
